<template>
  <crud-data-table
    :items="paymentStatuses"
    :headers="headers"
    :loading="isLoading"
    :search-placeholder="$t('global.crudDataTable.action.searchByTitlePlaceholder')"
    :no-data-message="$t('noDataText')"
  >
    <template v-slot:create>
      <create-payment-status-dialog />
    </template>

    <template v-slot:confirmationToDelete>
      <delete-payment-status-dialog @onDeletePaymentStatus="onDeletePaymentStatusCallback = $event" />
    </template>

    <template v-slot:title="props">
      <edit-title-dialog
        v-model="props.item.title"
        :item-id="props.item.id"
      />
    </template>

    <template v-slot:color="props">
      <edit-color-dialog
        v-model="props.item.color"
        :item-id="props.item.id"
      />
    </template>

    <template v-slot:count="{ item: { count } }">
      {{ $t('global.crudDataTable.body.countText', { n: count }) }}
    </template>

    <template v-slot:createdAt="{ item: { createdAt } }">
      {{ createdAt | formatDateToRelativeTime }}
    </template>

    <template v-slot:updatedAt="{ item: { updatedAt } }">
      {{ updatedAt | formatDateToRelativeTime }}
    </template>

    <template v-slot:delete="{ item }">
      <v-btn
        icon
        @click="onDeletePaymentStatusCallback(item)"
      >
        <v-icon>
          mdi-trash-can-outline
        </v-icon>
      </v-btn>
    </template>
  </crud-data-table>
</template>

<script>
  import DatesMixin from '@/mixins/date'
  import getTableHeaders from './table-headers'
  import { get } from 'vuex-pathify'
  // components
  import EditTitleDialog from './components/crud/UpdateTitle.vue'
  import EditColorDialog from './components/crud/UpdateColor'
  import DeletePaymentStatusDialog from './components/crud/Delete.vue'
  import CreatePaymentStatusDialog from './components/crud/Create.vue'

  export default {
    name: 'PaymentStatusesView',
    components: {
      EditTitleDialog,
      EditColorDialog,
      DeletePaymentStatusDialog,
      CreatePaymentStatusDialog,
    },
    mixins: [DatesMixin],
    data () {
      return {
        search: '',
        onDeletePaymentStatusCallback: null,
        headers: getTableHeaders(key => this.$t(key)),
      }
    },
    computed: {
      ...get('paymentStatuses', [
        'paymentStatuses',
        'isLoading',
      ]),
    },
    i18n: {
      messages: {
        'pt-BR': {
          noDataText: 'Nenhum status cadastrado.',
        },
        'en-US': {
          noDataText: 'No payment status registered.',
        },
      },
    },
  }
</script>
